# HG changeset patch
# Parent 23e7b958159872503bba3100e1cc36b14e8b93f1

diff -r 23e7b9581598 bin/ai/compat_0.7.nut
--- a/bin/ai/compat_0.7.nut	Wed Aug 31 20:36:09 2011 +0200
+++ b/bin/ai/compat_0.7.nut	Wed Sep 07 19:13:24 2011 +0200
@@ -326,3 +326,16 @@
 {
 	return AICompany.GetQuarterlyCompanyValue(company, AICompany.CURRENT_QUARTER);
 }
+
+// AirportType enum
+AIAirport.AT_SMALL         <-   0; // The small airport.
+AIAirport.AT_LARGE         <-   1; // The large airport.
+AIAirport.AT_METROPOLITAN  <-   3; // The metropolitan airport.
+AIAirport.AT_INTERNATIONAL <-   4; // The international airport.
+AIAirport.AT_COMMUTER      <-   5; // The commuter airport.
+AIAirport.AT_INTERCON      <-   7; // The intercontinental airport.
+
+AIAirport.AT_HELIPORT      <-   2; // The heliport.
+AIAirport.AT_HELISTATION   <-   8; // The helistation.
+AIAirport.AT_HELIDEPOT     <-   6; // The helidepot.
+AIAirport.AT_INVALID       <- 255; // Invalid airport.
diff -r 23e7b9581598 bin/ai/compat_1.0.nut
--- a/bin/ai/compat_1.0.nut	Wed Aug 31 20:36:09 2011 +0200
+++ b/bin/ai/compat_1.0.nut	Wed Sep 07 19:13:24 2011 +0200
@@ -77,3 +77,16 @@
 {
 	return AICompany.GetQuarterlyCompanyValue(company, AICompany.CURRENT_QUARTER);
 }
+
+// AirportType enum
+AIAirport.AT_SMALL         <-   0; // The small airport.
+AIAirport.AT_LARGE         <-   1; // The large airport.
+AIAirport.AT_METROPOLITAN  <-   3; // The metropolitan airport.
+AIAirport.AT_INTERNATIONAL <-   4; // The international airport.
+AIAirport.AT_COMMUTER      <-   5; // The commuter airport.
+AIAirport.AT_INTERCON      <-   7; // The intercontinental airport.
+
+AIAirport.AT_HELIPORT      <-   2; // The heliport.
+AIAirport.AT_HELISTATION   <-   8; // The helistation.
+AIAirport.AT_HELIDEPOT     <-   6; // The helidepot.
+AIAirport.AT_INVALID       <- 255; // Invalid airport.
diff -r 23e7b9581598 bin/ai/compat_1.1.nut
--- a/bin/ai/compat_1.1.nut	Wed Aug 31 20:36:09 2011 +0200
+++ b/bin/ai/compat_1.1.nut	Wed Sep 07 19:13:24 2011 +0200
@@ -13,3 +13,16 @@
 {
 	return AICompany.GetQuarterlyCompanyValue(company, AICompany.CURRENT_QUARTER);
 }
+
+// AirportType enum
+AIAirport.AT_SMALL         <-   0; // The small airport.
+AIAirport.AT_LARGE         <-   1; // The large airport.
+AIAirport.AT_METROPOLITAN  <-   3; // The metropolitan airport.
+AIAirport.AT_INTERNATIONAL <-   4; // The international airport.
+AIAirport.AT_COMMUTER      <-   5; // The commuter airport.
+AIAirport.AT_INTERCON      <-   7; // The intercontinental airport.
+
+AIAirport.AT_HELIPORT      <-   2; // The heliport.
+AIAirport.AT_HELISTATION   <-   8; // The helistation.
+AIAirport.AT_HELIDEPOT     <-   6; // The helidepot.
+AIAirport.AT_INVALID       <- 255; // Invalid airport.
diff -r 23e7b9581598 projects/openttd_vs90.vcproj
--- a/projects/openttd_vs90.vcproj	Wed Aug 31 20:36:09 2011 +0200
+++ b/projects/openttd_vs90.vcproj	Wed Sep 07 19:13:24 2011 +0200
@@ -2730,6 +2730,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\ai\api\ai_airporttypelist.hpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ai\api\ai_base.hpp"
 				>
 			</File>
@@ -2946,6 +2950,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\ai\api\ai_airporttypelist.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ai\api\ai_base.cpp"
 				>
 			</File>
diff -r 23e7b9581598 source.list
--- a/source.list	Wed Aug 31 20:36:09 2011 +0200
+++ b/source.list	Wed Sep 07 19:13:24 2011 +0200
@@ -625,6 +625,7 @@
 # AI API
 ai/api/ai_accounting.hpp
 ai/api/ai_airport.hpp
+ai/api/ai_airporttypelist.hpp
 ai/api/ai_base.hpp
 ai/api/ai_basestation.hpp
 ai/api/ai_bridge.hpp
@@ -680,6 +681,7 @@
 # AI API Implementation
 ai/api/ai_accounting.cpp
 ai/api/ai_airport.cpp
+ai/api/ai_airporttypelist.cpp
 ai/api/ai_base.cpp
 ai/api/ai_basestation.cpp
 ai/api/ai_bridge.cpp
diff -r 23e7b9581598 src/ai/ai_instance.cpp
--- a/src/ai/ai_instance.cpp	Wed Aug 31 20:36:09 2011 +0200
+++ b/src/ai/ai_instance.cpp	Wed Sep 07 19:13:24 2011 +0200
@@ -25,6 +25,7 @@
  * Note: this line a marker in squirrel_export.sh. Do not change! */
 #include "api/ai_accounting.hpp.sq"
 #include "api/ai_airport.hpp.sq"
+#include "api/ai_airporttypelist.hpp.sq"
 #include "api/ai_base.hpp.sq"
 #include "api/ai_basestation.hpp.sq"
 #include "api/ai_bridge.hpp.sq"
@@ -177,6 +178,7 @@
 	SQAIList_Register(this->engine);
 	SQAIAccounting_Register(this->engine);
 	SQAIAirport_Register(this->engine);
+	SQAIAirportTypeList_Register(this->engine);
 	SQAIBase_Register(this->engine);
 	SQAIBaseStation_Register(this->engine);
 	SQAIBridge_Register(this->engine);
diff -r 23e7b9581598 src/ai/api/ai_airport.cpp
--- a/src/ai/api/ai_airport.cpp	Wed Aug 31 20:36:09 2011 +0200
+++ b/src/ai/api/ai_airport.cpp	Wed Sep 07 19:13:24 2011 +0200
@@ -113,7 +113,7 @@
 	return st->airport.GetHangarTile(0);
 }
 
-/* static */ AIAirport::AirportType AIAirport::GetAirportType(TileIndex tile)
+/* static */ AirportType AIAirport::GetAirportType(TileIndex tile)
 {
 	if (!AITile::IsStationTile(tile)) return AT_INVALID;
 
diff -r 23e7b9581598 src/ai/api/ai_airport.hpp
--- a/src/ai/api/ai_airport.hpp	Wed Aug 31 20:36:09 2011 +0200
+++ b/src/ai/api/ai_airport.hpp	Wed Sep 07 19:13:24 2011 +0200
@@ -23,26 +23,6 @@
 	static const char *GetClassName() { return "AIAirport"; }
 
 	/**
-	 * The types of airports available in the game.
-	 */
-	enum AirportType {
-		/* Note: the values _are_ important as they represent an in-game value */
-		AT_SMALL         =   0, ///< The small airport.
-		AT_LARGE         =   1, ///< The large airport.
-		AT_METROPOLITAN  =   3, ///< The metropolitan airport.
-		AT_INTERNATIONAL =   4, ///< The international airport.
-		AT_COMMUTER      =   5, ///< The commuter airport.
-		AT_INTERCON      =   7, ///< The intercontinental airport.
-
-		/* Next are the airports which only have helicopter platforms */
-		AT_HELIPORT      =   2, ///< The heliport.
-		AT_HELISTATION   =   8, ///< The helistation.
-		AT_HELIDEPOT     =   6, ///< The helidepot.
-
-		AT_INVALID       = 255, ///< Invalid airport.
-	};
-
-	/**
 	 * All plane types available.
 	 */
 	enum PlaneType {
diff -r 23e7b9581598 src/ai/api/ai_airport.hpp.sq
--- a/src/ai/api/ai_airport.hpp.sq	Wed Aug 31 20:36:09 2011 +0200
+++ b/src/ai/api/ai_airport.hpp.sq	Wed Sep 07 19:13:24 2011 +0200
@@ -13,8 +13,6 @@
 
 namespace SQConvert {
 	/* Allow enums to be used as Squirrel parameters */
-	template <> AIAirport::AirportType GetParam(ForceType<AIAirport::AirportType>, HSQUIRRELVM vm, int index, SQAutoFreePointers *ptr) { SQInteger tmp; sq_getinteger(vm, index, &tmp); return (AIAirport::AirportType)tmp; }
-	template <> int Return<AIAirport::AirportType>(HSQUIRRELVM vm, AIAirport::AirportType res) { sq_pushinteger(vm, (int32)res); return 1; }
 	template <> AIAirport::PlaneType GetParam(ForceType<AIAirport::PlaneType>, HSQUIRRELVM vm, int index, SQAutoFreePointers *ptr) { SQInteger tmp; sq_getinteger(vm, index, &tmp); return (AIAirport::PlaneType)tmp; }
 	template <> int Return<AIAirport::PlaneType>(HSQUIRRELVM vm, AIAirport::PlaneType res) { sq_pushinteger(vm, (int32)res); return 1; }
 
@@ -32,20 +30,10 @@
 	SQAIAirport.PreRegister(engine);
 	SQAIAirport.AddConstructor<void (AIAirport::*)(), 1>(engine, "x");
 
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_SMALL,         "AT_SMALL");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_LARGE,         "AT_LARGE");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_METROPOLITAN,  "AT_METROPOLITAN");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_INTERNATIONAL, "AT_INTERNATIONAL");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_COMMUTER,      "AT_COMMUTER");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_INTERCON,      "AT_INTERCON");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_HELIPORT,      "AT_HELIPORT");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_HELISTATION,   "AT_HELISTATION");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_HELIDEPOT,     "AT_HELIDEPOT");
-	SQAIAirport.DefSQConst(engine, AIAirport::AT_INVALID,       "AT_INVALID");
-	SQAIAirport.DefSQConst(engine, AIAirport::PT_HELICOPTER,    "PT_HELICOPTER");
-	SQAIAirport.DefSQConst(engine, AIAirport::PT_SMALL_PLANE,   "PT_SMALL_PLANE");
-	SQAIAirport.DefSQConst(engine, AIAirport::PT_BIG_PLANE,     "PT_BIG_PLANE");
-	SQAIAirport.DefSQConst(engine, AIAirport::PT_INVALID,       "PT_INVALID");
+	SQAIAirport.DefSQConst(engine, AIAirport::PT_HELICOPTER,  "PT_HELICOPTER");
+	SQAIAirport.DefSQConst(engine, AIAirport::PT_SMALL_PLANE, "PT_SMALL_PLANE");
+	SQAIAirport.DefSQConst(engine, AIAirport::PT_BIG_PLANE,   "PT_BIG_PLANE");
+	SQAIAirport.DefSQConst(engine, AIAirport::PT_INVALID,     "PT_INVALID");
 
 	SQAIAirport.DefSQStaticMethod(engine, &AIAirport::IsValidAirportType,            "IsValidAirportType",            2, ".i");
 	SQAIAirport.DefSQStaticMethod(engine, &AIAirport::IsAirportInformationAvailable, "IsAirportInformationAvailable", 2, ".i");
diff -r 23e7b9581598 src/ai/api/ai_airporttypelist.cpp
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/ai/api/ai_airporttypelist.cpp	Wed Sep 07 19:13:24 2011 +0200
@@ -0,0 +1,22 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file ai_airporttypelist.cpp Implementation of AIAirportTypeList. */
+
+#include "../../stdafx.h"
+#include "ai_airporttypelist.hpp"
+#include "ai_airport.hpp"
+#include "../../airport.h"
+
+AIAirportTypeList::AIAirportTypeList()
+{
+	for (byte j = 0; j <= NUM_AIRPORTS; j++) {
+		if (AIAirport::IsAirportInformationAvailable(j)) this->AddItem(j);
+	}
+}
diff -r 23e7b9581598 src/ai/api/ai_airporttypelist.hpp
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/ai/api/ai_airporttypelist.hpp	Wed Sep 07 19:13:24 2011 +0200
@@ -0,0 +1,28 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file ai_airporttypelist.hpp List all airport types. */
+
+#ifndef AI_AIRPORTTYPELIST_HPP
+#define AI_AIRPORTTYPELIST_HPP
+
+#include "ai_list.hpp"
+
+/**
+ * Creates a list of industries that are currently on the map.
+ * @ingroup AIList
+ */
+class AIAirportTypeList : public AIList {
+public:
+	/** Get the name of this class to identify it towards squirrel. */
+	static const char *GetClassName() { return "AIAirportTypeList"; }
+	AIAirportTypeList();
+};
+
+#endif /* AI_AIRPORTTYPELIST_HPP */
diff -r 23e7b9581598 src/ai/api/ai_types.hpp
--- a/src/ai/api/ai_types.hpp	Wed Aug 31 20:36:09 2011 +0200
+++ b/src/ai/api/ai_types.hpp	Wed Sep 07 19:13:24 2011 +0200
@@ -100,6 +100,7 @@
 typedef uint32 VehicleID;    ///< The ID of a vehicle.
 
 /* Types we defined ourself, as the OpenTTD core doesn't have them (yet) */
+typedef byte AirportType;    ///< The ID of an airport type.
 typedef uint AIErrorType;    ///< The types of errors inside the NoAI framework.
 typedef BridgeType BridgeID; ///< The ID of a bridge.
 
